## AFindex.pl / make "*_IDX" file from "*_LOG" file.
## Copyright 1996-99 (C) Akira Funai (akira@funai.com).

open(_LOG,$LOG_FILE);

$pos = $whole_s = -s _LOG;

undef $first_num;
undef @mt_idx;

while (<_LOG>) {

	($num,$p_num,$type,$ltime,$ftime) = split(/\x08/);

	if ($type) {

		$ym = &mt($ftime);
		if ($ym ne $current_ym) {
			unshift(@mt_idx,"$ym,$num,$pos");
			$current_ym = $ym;
		}

		$p_num[$num] = $p_num;
		$pos[$num]   = $pos;

		$first_num = $num if ($num<$first_num || !$first_num);

	}

	$pos = $whole_s-tell(_LOG);

}

undef $idx;
for ($i=$#pos; $i>=$first_num; $i--) {
	$idx .= pack($IDX_TMPL,$i,$p_num[$i],$pos[$i]);
}


$idx_sum = join('#',length($idx),-M _LOG);
$mt_idx  = join('#',@mt_idx);

# rename($IDX_FILE,"$IDX_FILE~"); # for Debug.

open(IDX,">$IDX_FILE");
print IDX join("\n",$idx_sum,($#pos>0 ? $#pos : 0),$mt_idx,$idx);
close(IDX);
chmod($FILE_MODE,$IDX_FILE);


$Remote_host = $Remote_host || $ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'};
open(ERR,">>_ERR");
print ERR &gettime($Now),", from $Remote_host -- $IDX_FILE Rebuilded.\n";
close(ERR);
chmod($FILE_MODE,"_ERR");

1;
