## AFlist.pl / show article list.
## Copyright 1996-99 (C) Akira Funai (akira@funai.com).

$Thread   =$Arg{'tr'};
$Month    =$Arg{'mt'};
$New      =$Arg{'nw'};
$page     =$Arg{'pg'};
$core     =$Arg{'cr'};
$Readthem =$Arg{'rt'};


if (!$Thread && !$New && $Month<1){
	$Login =1 if !$Month; # 1st Entrance.
	&update_lv;
}


open(LOG,$LOG_FILE);

if ($Thread){ &thread;}
elsif ($New){ &new;}
else { &month;}

$num_pages =int(@Logs/$PAGE_SIZE);
$num_pages++ if (!$num_pages || @Logs%$PAGE_SIZE>=$PAGE_MIN);

$page =int((@Logs-$core_ptr)/$PAGE_SIZE)+1 if $core;
$page =$num_pages if ($page>$num_pages || $page eq 'l');
$page =1 if $page<1;

$#Logs-=($page-1)*$PAGE_SIZE;
$Num_logs =$PAGE_SIZE;
$Num_logs+=$PAGE_MIN if $page==$num_pages;


# List_head.

if ($Thread){
	$MES{'LIST_HEAD'} = $MES{'MODE_TR'}.': "'.(split(/\x08/,$Logs[$#Logs]))[6].'"';
	$My_prm ="tr=$Thread";
}
if ($Month){
	$f_mt = &getmstr($Month);
	$l_mt = &getmstr((split(/\x08/,$Logs[$[]))[4]);
	$MES{'LIST_HEAD'} = $MES{$Recent?'MODE_RC':'MODE_MT'}.": $f_mt";
	$MES{'LIST_HEAD'}.= " - $l_mt" if $f_mt ne $l_mt;
	$My_prm ="mt=$Month";
}
if ($New){
	$MES{'LIST_HEAD'} = $MES{'MODE_NW'};
	$My_prm ="nw=$New";
}

if ($num_pages>1){
	$MES{'LIST_HEAD'}.= ", Page $page";
	$Pg_prm ="pg=$page";
}


# List_foot.

@my_prev = ($My_prm,'pg='.($page-1)) if $page>1;
@my_next = ($My_prm,'pg='.($page+1)) if $page<$num_pages;

$rt_prm =$Readthem ? 'rt=1' : '';

$prev_pg = &anchor($MES{'PREV_PG'},@my_prev && (@my_prev,$rt_prm));
$next_pg = &anchor($MES{'NEXT_PG'},@my_next && (@my_next,$rt_prm));

if ($num_pages>1){
	for (1..$num_pages){
		$list_pg.= &anchor(sprintf("%0.2d",$_),($_!=$page) && ($My_prm,"pg=$_",$rt_prm)).' ';
	}
	$list_pg.='| ';
}

$MES{'FOOT_MENU'} ="<pre>\n\n".$MES{$Thread ? 'FOOT_TR' : 'FOOT_NB'}.
 "\n$prev_pg | $list_pg$next_pg\n</pre>\n";

$My_prm .= '.' if $Recent; # oops...

if (@mt>1 && (!$Recent || $mt_num>$[)){
	undef $mt_menu;
	for ($[..$#mt){ 
		$mt_prm = ($_ ne $mt_num && (!$Recent || $_<$mt_num)) ? "mt=$mt[$_]" : '';
		$mt_menu .= ($_ % 6 ? ' | ' : "\n").&anchor(&getmstr($mt[$_]),$mt_prm);
	}
	$mt_menu .= ' ' x ((6-@mt%6)%6*length(" | $MES{'MT01'}")) if @mt>6;
	$MES{'MONTH_MENU'} =<<EOF;
<pre>$mt_menu
</pre>
EOF
}



sub new{
	while(<LOG>){
		push(@Logs,$_);
		last if /^$New\x08/;
	}
}

sub month{
	if ($Month<1){ # recent.
		while(<LOG>){
			($num,$udf,$udf,$ltime,$ftime) =split(/\x08/);
			next if !$ltime;
			($ltime > $Last_visit) ? ($New =$num) : ($New && last);
			push(@Logs,$_);
			last if !$New && @Logs>=$PAGE_MIN;
		}
		($Readthem =1,return) if $New;

		$Month =&mt($ftime).'.';
		$page = 'l';
	}
	$Recent =1 if $Month =~ s/\.$//;

	&open_idx;
	for(split(/#/,$Mt_idx)){
		($mt,$num,$pos) =split(/,/);
		push(@mt,$mt);
		($mt_num,$hd_num,$hd_pos,$tl_pos) =($#mt,$num,$pos,(-s LOG)-$prev_pos)
		 if $mt == $Month;
		$prev_pos =$pos;
	}
	return if !$hd_num;

	&push_log($hd_num,$hd_pos) if !$Recent;
	&push_log while tell(LOG) < $tl_pos;

	@my_prev =("mt=$mt[$mt_num-1]",'pg=l') if $mt_num>$[;
	@my_next =("mt=$mt[$mt_num+1]") if $mt_num<$#mt && !$Recent;
}

sub thread{
	&open_idx;

	while(read(IDX,$idx,$IDX_LEN)){
		($num,$p_num,$pos) =unpack($IDX_TMPL,$idx);
		if ($p_num eq $Thread){
			&push_log($num,$pos);
			$next_parent =$parent if $num eq $p_num;
		}
		next if $num ne $p_num;
		$parent =$num;
		last if $num<$Thread;
	}

	@my_prev =("tr=$parent",'pg=l') if $parent<$Thread;
	@my_next =("tr=$next_parent")   if $next_parent;
}

sub push_log{
	seek(LOG,-$_[1],2) if $_[1];
	$_ =<LOG>;
	(&rebuild_idx,&bye('idxerr')) if ($_[0] && !/^$_[0]\x08/);
	push(@Logs,$_);
	$core_ptr =@Logs if /^$core\x08/;
}

sub getmstr{
	$_[0] =~ /^(..)(..)/;
	sprintf($MES{"MT$2"},$1);
}

1;
