## AFsubmit.pl / write (or delete) articles.
## Copyright 1996-99 (C) Akira Funai (akira@funai.com).

&remote_host;

undef @logs;

open(LOG,$LOG_FILE);
$log_s = -s LOG;

if ($Arg{'tt'} =~ /^del(ete)?\s+([\d\,\-]+)$/i){
	$del_nums = $2;
	&get_del_num($del_nums);

	while(%del_num && ($_=<LOG>)){
		($num) = split(/\x08/);
		next if !$del_num{$num};
		push(@Logs,$_);
		delete $del_num{$num};
	}
	&bye('nolog',join(',',keys(%del_num))) if %del_num;

	$MES{'LIST_HEAD'} = $MES{'MODE_DL'};
	$My_prm = 'tt='.&urlencode($Arg{'tt'});
	$Readthem = $Arg{'rt'};

	&cancel_form($del_nums);
	$Usr_level = 0;
}
else {	
	&open_idx;
	chop($Mt_idx,$Last_num);
	read(IDX,$idx,-s IDX);

	if ($Arg{'dn'}){ &delete_log;}
	elsif ($Arg{'ct'}){ &write_log;}
	else{ &get_out;}

	undef $last_ftime;
	$i =$[;
	while ($log = ($i<=$#logs) ? $logs[$i] : <LOG>){
		($num,$p_num,$type,$ltime,$ftime,@rest) = split(/\x08/,$log);
	
		$last_ftime =$ftime if !$last_ftime;
	
		if ($new_type{$num}){
			$type =$new_type{$num} if $type;
			delete $new_type{$num};
		}
		$new_type{$p_num} ='P' if $new_type{$p_num};
	
		$logs[$i] =join("\x08",$num,$p_num,$type,$ltime,$ftime,@rest);
		last if ($last_ftime && !%new_type);
		$i++;
	}
	$last_mt =&mt($last_ftime);

	$Mt_idx =~ s/(.*)(^|#)$last_mt.*/$1/;
	$Mt_idx.='#' if $Mt_idx;
	$Mt_idx.=join(',',$last_mt,$Last_num,$log_s) if $log_s;


	open(TMP,">_TMP$$") || &bye('makefl');
	print TMP @logs;
	while (read(LOG,$blk,128*1024)){ print TMP $blk;}
	close(LOG);
	close(TMP);

	&bye('makefl') if $log_s != -s "_TMP$$";
	rename("_TMP$$",$LOG_FILE) || &bye('rename');


	chmod($FILE_MODE,$LOG_FILE);


	$idx_sum =join('#',length($idx),-M $LOG_FILE);

	open(IDX,">$IDX_FILE");
	print IDX join("\n",$idx_sum,$Last_num,$Mt_idx,$idx);
	close(IDX);


	$Arg{'mt'} ='rc';
	$Now = time; # to prevent unread problem...
}


sub delete_log{
	$my_pw =$Arg{'dp'};
	&get_del_num($Arg{'dn'});

	chmod(0444,'_PW') || &bye('chmod');
	open(PW,"_PW");
	$SYSOP_PW = <PW>;
	close(PW);
	chmod(0222,'_PW');
	$IS_SYSOP = (crypt($my_pw,$SYSOP_PW) eq $SYSOP_PW) ? 1 : 0;

	$num_logs = 0;
	while (<LOG>){
		push(@logs,$_);

		($lognum,$p_num,$type,$ltime,$ftime,$handle,$title,
		 $article,$email,$remote_host,$del_pw,@rest) = split(/\x08/);
		next if !$p_num;

		$num_logs++;
		next unless $del_num{$lognum};

		if (!$IS_SYSOP){
			&bye('badpw',$lognum) if crypt($my_pw,$del_pw) ne $del_pw;
			&bye('replied',$lognum) if $type eq 'P';
		}

		$new_type{$p_num} ='C';

		if ($num_logs == 1){
			$_ = pop(@logs);
			$num_logs--;
			$log_s -= length($_);
			&delete_idx($lognum);
			delete $new_type{$lognum};
		}
		else {
			$logs[$#logs] =join("\x08",$lognum,$p_num,'0',$ltime,$ftime,$handle,$title,
			                    $article,$email,$remote_host,$del_pw,@rest);

			&delete_idx($lognum);
		}

		$MES{'TITLE'} = $title;
		$MES{'PARENT'} = $p_num;
		$MES{'QUOTE'} = $article;
		$MES{'QUOTE'} =~ tr/\x0f/\n/;

		delete $del_num{$lognum};
		last if !%del_num;
	}

	&bye('nolog',join(',',keys(%del_num))) if %del_num;
}

sub delete_idx{
	local($num) = @_;
	if ($num == $Last_num){
		substr($idx,0,$IDX_LEN) ='';
		$Last_num--;
	}
	elsif ($num < $Last_num){
		substr($idx,($Last_num-$num)*$IDX_LEN,$IDX_LEN) =pack($IDX_TMPL,$num);
	}
}


sub write_log{
	&bye('cantwrite') if $Usr_level<2;
	&bye('wrongarg')  if $GET_arg =~ /ct\=/;

	srand(time^$$^-s _);

	$my_title   =$Arg{'tt'};
	$my_article =$Arg{'ct'};
	$my_parent  =$Arg{'pr'};
	$my_handle  =$Arg{'gh'};
	&bye('handle') if $my_handle !~ /\S/;
	$my_email   =$Arg{'ge'};
	&bye('email') if $my_email !~ /\S/;

	$jis = 0;
	for ($my_title,$my_article,$my_parent,$my_handle,$my_email){
		$jis = 1 if /\x1b/;
	}
	&convert('euc') if $jis;

	&bye('wrongarg') if $my_parent =~ /\D/;

	while(<LOG>){
		push(@logs,$_);
		($udf,$udf,$udf,$prev_ltime,$udf,$udf,$udf,$prev_article) =split(/\x08/);
		last if $prev_ltime;
	}

	$my_lognum =$Last_num+1;
	$Last_num++;
	$my_parent =$my_lognum if ($my_parent<1 || $my_title!~/^Re:/i);

	$Now++ if $prev_ltime == $Now;

	for ($my_title,$my_handle,$my_email){
		s#\<#\&lt\;#g;
		s#\>#\&gt\;#g;
		s#\"#\&quot\;#g;
	}

	$my_title ='No Title' if $my_title eq '';

	$my_article =~ s#(^|[^\=\"\'\>])(http://|mailto:)([\x21-\x7e]+)#$1<a href="$2$3">$2$3</a>#g;
	$my_article = &closetags($my_article);
	$my_article =~ s#\x0d?\x0a#\x0f#g;
	$my_article =~ tr#\x0d##d;

	$my_article =~ s/in #(\d+):\x0f/in <a href="${My_url}rd=$1;rt=1">#$1<\/a>:\x0f/g;
	$my_article =~ s#\x0f*$#\x0f#;

	if ($CHARSET =~ /ISO\-2022\-JP/i){ &convert('jis');}
	elsif ($CHARSET =~ /(EUC\-JP|X\-EUC)/i){ &convert('euc');}
	else{ &convert('sjis');}

	&get_out if !$my_article || ($my_article eq $prev_article);

	$my_pswd =&random_str(10);

	$my_log =join("\x08",$my_lognum,$my_parent,'C',$Now,&gettime($Now),$my_handle,
	               $my_title,$my_article,$my_email,$Remote_host,
	               crypt($my_pswd,&random_str(2)),"\n");

	unshift(@logs,$my_log);

	$new_type{$my_parent} ='P' if $my_parent != $my_lognum;

	$log_s+=length($my_log);
	$idx =pack($IDX_TMPL,$my_lognum,$my_parent,$log_s).$idx;


	if (($my_handle ne $C_Arg{'hd'} || $my_email ne $C_Arg{'em'}) && $Arg{'sc'}){
		$C_Arg{'hd'} =$my_handle;
		$C_Arg{'em'} =$my_email;
		&set_cookie('ck',join("\x07",%C_Arg),$Now+180*$DAY);
	}

	&cancel_form($my_lognum,$my_pswd);
}

sub get_del_num{
	undef %del_num;
	for (split(/,/,$_[0])){
		if (/(\d+)\-(\d+)/){
			for ($1..$2){ $del_num{$_} = 1;}
		}
		elsif (/^\d+$/){ $del_num{$_} = 1;}
	}
}

sub cancel_form{
	local($del_num,$del_pw) = @_;

	$cancel_mes =sprintf($MES{'FORM_CANCEL'},$del_num);
	$dp = $del_pw ? "<input type=\"hidden\" name=\"dp\" value=\"$del_pw\">"
	              : "$MES{'FORM_PW'}<input type=\"password\" name=\"dp\" size=\"10\"><br>";

	$MES{'CANCEL_FORM'} = <<EOF;
<form method="post" action="$My_url">
<input type="hidden" name="dn" value="$del_num">
$dp
<input type="submit" value="$cancel_mes">
</form>
EOF
}

sub convert{
	local($to) =@_;
	&jcode'convert(*my_handle, $to);
	&jcode'convert(*my_email,  $to);
	&jcode'convert(*my_title,  $to);
	&jcode'convert(*my_article,$to);
}

sub closetags{
	package CloseTags;
	
	if (!@inline_pair){
		@inline_pair   = ('A','ABBR','ACRONYM','B','BDO','CITE','CODE','DFN','EM',
		                  'I','KBD','LABEL','Q','S','SAMP','STRIKE','STRONG','TT','U','VAR',

		                  'BIG','BLINK','CENTER','FONT','SMALL','SUB','SUP'); # This Line = illegal.

		@inline_empty  = ('BR'); # illegal.

		for  (@inline_pair){ $inline_pair{$_}  = 1;}
		for (@inline_empty){ $inline_empty{$_} = 1;}
	}

	($head,@body) = split(/</,$_[0]);
	undef @open_tags;

	foreach(@body){
		next unless />/;

		($element) = split(/[\s\n>]/);
		$element =~ tr/a-z/A-Z/;
		$is_close = ($element =~ s#(^/)##);

		if (!$inline_pair{$element}){
			s/>/&gt;/g if !$inline_empty{$element};
			next;
		}

		if ($is_close){
			$last_element = pop(@open_tags);
			if ($last_element ne $element){
				$last_element ? s#^[^>]*#/$last_element# : s#^[^>]*##;
			}
		}
		else { push(@open_tags,$element);}
	}

	$result =join('<',$head,@body);

	$result =~ s#\<\>##g;
	$result =~ s#\<([^\<\>]*)\>#\x08$1\x0f#g;
	$result =~ s#\<#\&lt\;#g;
	$result =~ s#\>#\&gt\;#g;
	$result =~ s#\x08#\<#g;
	$result =~ s#\x0f#\>#g;

	while ($_ = pop(@open_tags)){ $result.="</${_}>";}

	$result;
}

sub remote_host{
	$REM_HOST = $ENV{'REMOTE_HOST'};
	$REM_ADDR = $ENV{'REMOTE_ADDR'};
	$FORWARD = $ENV{'HTTP_X_FORWARDED_FOR'} || $ENV{'HTTP_FORWARDED'};

	if ($FORWARD ||
	    $ENV{'HTTP_VIA'} ||
	    $ENV{'HTTP_CACHE_INFO'} ||
	    $ENV{'HTTP_PROXY_CONNECTION'}){ # Proxy.
	    &get_out if !$FORWARD; # Anonymous.
	}

	if (!$REM_HOST || $REM_HOST eq $REM_ADDR){
		$ip = pack('c4',split(/\./,$REM_ADDR));
		$REM_HOST = gethostbyaddr($ip,2) || $REM_ADDR;
	}

	if ($FORWARD){
		($FORWARD) = split(/[\,\n]/,$FORWARD);
		$FORWARD =~ s#by\s*(for)?\s*(.*)#$2#;
		$ip = pack('c4',split(/\./,$FORWARD));
		$FORWARD = gethostbyaddr($ip,2) || $FORWARD;
	}
	
	$Remote_host = $FORWARD ? "$FORWARD (via $REM_HOST)" : $REM_HOST;
}

sub get_out{
	&clean_up;
	print "Status: 204\n\n";
	exit(0);
}

sub random_str{
	$alphanum = join('','a'..'z','A'..'Z','0'..'9');
	local($str) ='';

	for (1..$_[0]){ $str .= substr($alphanum,int(rand(62)),1);}
	$str;
}

1;
